import 'package:doctor_app_flutter/core/viewModel/livecare_view_model.dart';
import 'package:doctor_app_flutter/core/viewModel/project_view_model.dart';
import 'package:doctor_app_flutter/util/translations_delegate_base.dart';
import 'package:firebase_core/firebase_core.dart';
import 'package:flutter/material.dart';
import 'package:flutter_localizations/flutter_localizations.dart';
import 'package:hexcolor/hexcolor.dart';
import 'package:provider/provider.dart';

import './config/size_config.dart';
import 'core/viewModel/auth_view_model.dart';
import 'core/viewModel/hospital_view_model.dart';
import './routes.dart';
import 'config/config.dart';
import 'locator.dart';

void main() async {
  WidgetsFlutterBinding.ensureInitialized();
  await Firebase.initializeApp();
  setupLocator();
  runApp(MyApp());
}

class MyApp extends StatelessWidget {
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    AppGlobal.CONTEX = context;
    return LayoutBuilder(
      builder: (context, constraints) {
        return OrientationBuilder(builder: (context, orientation) {
          SizeConfig().init(constraints, orientation);
          return MultiProvider(
            providers: [
              ChangeNotifierProvider<AuthViewModel>(
                  create: (context) => AuthViewModel()),
              ChangeNotifierProvider<HospitalViewModel>(
                  create: (context) => HospitalViewModel()),
              ChangeNotifierProvider<ProjectViewModel>(
                create: (context) => ProjectViewModel(),
              ),
              ChangeNotifierProvider<LiveCareViewModel>(
                create: (context) => LiveCareViewModel(),
              ),
            ],
            child: Consumer<ProjectViewModel>(
                builder: (context, projectProvider, child) => MaterialApp(
                      showSemanticsDebugger: false,
                      title: 'Flutter Demo',
                      locale: projectProvider.appLocal,
                      localizationsDelegates: [
                        TranslationBaseDelegate(),
                        GlobalMaterialLocalizations.delegate,
                        GlobalWidgetsLocalizations.delegate,
                      ],
                      supportedLocales: [
                        const Locale('ar', ''), // Arabic
                        const Locale('en', ''), // English
                      ],
                      theme: ThemeData(
                        primarySwatch: Colors.grey,
                        primaryColor: Colors.grey,
                        buttonColor: HexColor('#B8382C'),
                        fontFamily: 'WorkSans',
                        dividerColor: Colors.grey[350],
                        backgroundColor: Color.fromRGBO(255, 255, 255, 1),
                      ),
                      initialRoute: INIT_ROUTE,
                      routes: routes,
                      debugShowCheckedModeBanner: false,
                    )),
          );
        });
      },
    );
  }
}
